function [S] = all_in_DEP(S,c,deltas,flag_dist,n_points)

n_scale = length(deltas);
if n_points < S.nv
    S.points = fps_euclidean(S.X, n_points, 1);
else 
    S.points = 1:S.nv;
end

disp('compute distances'); tic;
if strcmp(flag_dist,'Dijkstra')
    S.dists = zeros(S.nv);
    shape.X = S.X(:,1); shape.Y = S.X(:,2); shape.Z = S.X(:,3); shape.TRIV = S.T;
    for j = 1:S.nv
        S.dists(j,:) = dijkstra_to_all(shape,j);        
    end
    clear shape;
elseif strcmp(flag_dist,'SpectroMeter')
    [S.dists] = SpectroMeterDists(S); 
end
toc

% compute diameter and normalize distanes
S.dists = S.dists./max(S.dists(:));

% compute area elements
S.Omega = abs(diag(sum(full(S.Ae),2)));
S.f0 = ones(n_points,1);


% compute DEP descriptor
tic
disp('compute DEP descriptor')
tmpDEP = zeros(n_points,n_scale);
for q = 1 : n_scale 
    S.D_norm = S.dists(S.points,S.points);
    S.D_norm(S.dists(S.points,S.points) > deltas(q)) = 1; % 0 non inv, 1 inv
    S.D_norm = ones(size(S.D_norm)) - S.D_norm; 

    tmpDEP(:,q) = computeDEPdesc(S.D_norm*S.Omega(S.points,S.points),c,S.f0);
end
toc

if n_points < S.nv
    [~, S.nearest] = min(L2_distance(S.X(S.points,:)',S.X'));
    S.nearest = knnsearch(S.X(S.points,:),S.X);
    S.DEP = tmpDEP(S.nearest,:); 
else
    S.DEP = tmpDEP; 
end